/*-------------------------------------------------------------------------
Developed By HelloApps, (http://www.helloapps.co.kr)
Email: splduino@gmail.com
All rights reserved © 2019, HelloApps Co., Ltd.
2018.10.14 Updated
-------------------------------------------------------------------------*/

#include <Arduino.h>
#include <SoftwareSerial.h>
#include "HelloWiFi.h"


void HelloWiFi::Write(byte v)
{
	write(v);
}

void HelloWiFi::Write(char v)
{
	write(v);
}

void HelloWiFi::Write(int v)
{
	write(v);
}

void HelloWiFi::Write(unsigned int v)
{
	write(v);
}

void HelloWiFi::Write(long v)
{
	write(v);
}

void HelloWiFi::Write(unsigned long v)
{
	write(v);
}

void HelloWiFi::Write(float v)
{
	write(v);
}

void HelloWiFi::Write(double v)
{
	write(v);
}


void HelloWiFi::Print(byte v)
{
	print(v);
}

void HelloWiFi::Print(char v)
{
	print(v);
}

void HelloWiFi::Print(int v)
{
	print(v);
}

void HelloWiFi::Print(unsigned int v)
{
	print(v);
}

void HelloWiFi::Print(long v)
{
	print(v);
}

void HelloWiFi::Print(unsigned long v)
{
	print(v);
}
void HelloWiFi::Print(float v)
{
	print(v);
}
void HelloWiFi::Print(double v)
{
	print(v);
}
void HelloWiFi::Print(String v)
{
	print(v);
}


void HelloWiFi::PrintLine(byte v)
{
	println();
}

void HelloWiFi::PrintLine(char v)
{
	println();
}

void HelloWiFi::PrintLine(int v)
{
	println();
}

void HelloWiFi::PrintLine(unsigned int v)
{
	println();
}

void HelloWiFi::PrintLine(long v)
{
	println();
}

void HelloWiFi::PrintLine(unsigned long v)
{
	println();
}

void HelloWiFi::PrintLine(float v)
{
	println();
}

void HelloWiFi::PrintLine(double v)
{
	println();
}


void HelloWiFi::PrintLine(String v)
{
	println();
}


int HelloWiFi::Read()
{
	return read();
}



//###########################################################################


String HelloWiFi::PrintMessage_v1()
{
	String res = "";
	
	while(available())
	{
		int b = read();
		char c = (char)b;
		
		res += c;

		if (c == '#')
		{
			data_start_flag = 1;
			recv_data = "";
		}
		else if (c == ';')
		{
			data_start_flag = 0;
		}
		else if (data_start_flag == 1)
		{
			recv_data = recv_data + c;
		}
	}		
	
	return res;
}


String HelloWiFi::Message()
{
	String res = "";
	
	while(available())
	{
		int b = read();
		char c = (char)b;				
		res += c;
	}
			
	return res;
}


String HelloWiFi::Ver()
{
	flush();
	String cmd = "VER;";
	print(cmd);
	
	delay(200);
	String recvData = readStringUntil('#');
	recvData = readStringUntil(';');	
	return recvData;
}


void HelloWiFi::SSID(String s)
{
	String cmd = "SSID ";
	cmd += s;
	cmd += ";";
	print(cmd);
}


String HelloWiFi::GetSSID()
{
	flush();
	String cmd = "SSID;";
	print(cmd);
	
	delay(200);
	String recvData = readStringUntil('#');
	recvData = readStringUntil(';');	
	return recvData;
}


void HelloWiFi::Password(String s)
{
	String cmd = "PWRD ";
	cmd += s;
	cmd += ";";
	print(cmd);
}



void HelloWiFi::Channel(String s)
{
	String cmd = "CHNL ";
	cmd += s;
	cmd += ";";
	print(cmd);
}


String HelloWiFi::GetChannel()
{
	flush();
	String cmd = "CHNL;";
	print(cmd);
	
	delay(200);
	String recvData = readStringUntil('#');
	recvData = readStringUntil(';');	
	return recvData;
}


String HelloWiFi::ChannelReassign()
{
	flush();
	String cmd = "CHNL_REASSIGN;";
	print(cmd);
	
	delay(200);
	String recvData = readStringUntil('#');
	recvData = readStringUntil(';');	
	return recvData;
}



void HelloWiFi::StartAP()
{
	String cmd = "START_AP;";
	print(cmd);
	delay(200);
}


void HelloWiFi::BeginAP()
{
	String cmd = "BEGIN_AP;";
	print(cmd);
	delay(200);
}

void HelloWiFi::BeginServer()
{
	String cmd = "BEGIN_SERVER;";
	print(cmd);
	delay(200);
}


//###########################################################################


String HelloWiFi::WiFiRead()
{
	flush();
	String cmd = "READ;";
	print(cmd);
	
	delay(200);
	String recvData = readStringUntil('#');
	recvData = readStringUntil(';');
	
	if (recvData.startsWith("#"))
		recvData = recvData.substring(1);
	
	return recvData;
}


String HelloWiFi::WiFiRead(String v)
{
	flush();
	String cmd = "READ ";
	cmd += v;
	cmd += ";";
	print(cmd);
	
	delay(200);
	String recvData = readStringUntil('#');
	recvData = readStringUntil(';');	
	return recvData;
}


//###########################################################################


void HelloWiFi::WiFiWrite(String v)
{
	String cmd = "WRITE ";
	cmd += v;
	cmd += ";";
	print(cmd);
}

void HelloWiFi::WiFiWrite(byte v)
{
	WiFiWrite(String(v));
}

void HelloWiFi::WiFiWrite(char v)
{
	WiFiWrite(String(v));
}

void HelloWiFi::WiFiWrite(int v)
{
	WiFiWrite(String(v));
}

void HelloWiFi::WiFiWrite(unsigned int v)
{
	WiFiWrite(String(v));
}

void HelloWiFi::WiFiWrite(long v)
{
	WiFiWrite(String(v));
}

void HelloWiFi::WiFiWrite(unsigned long v)
{
	WiFiWrite(String(v));
}

void HelloWiFi::WiFiWrite(float v)
{
	WiFiWrite(String(v));
}

void HelloWiFi::WiFiWrite(double v)
{
	WiFiWrite(String(v));
}


//###########################################################################


void HelloWiFi::WiFiWrite(String n, String v)
{
	String cmd = "WRITE ";
	cmd += n;
	cmd += " ";
	cmd += v;
	cmd += ";";
	print(cmd);
}

void HelloWiFi::WiFiWrite(String n, byte v)
{
	WiFiWrite(n, String(v));
}

void HelloWiFi::WiFiWrite(String n, char v)
{
	WiFiWrite(n, String(v));
}

void HelloWiFi::WiFiWrite(String n, int v)
{
	WiFiWrite(n, String(v));
}

void HelloWiFi::WiFiWrite(String n, unsigned int v)
{
	WiFiWrite(n, String(v));
}

void HelloWiFi::WiFiWrite(String n, long v)
{
	WiFiWrite(n, String(v));
}

void HelloWiFi::WiFiWrite(String n, unsigned long v)
{
	WiFiWrite(n, String(v));
}

void HelloWiFi::WiFiWrite(String n, float v)
{
	WiFiWrite(n, String(v));
}

void HelloWiFi::WiFiWrite(String n, double v)
{
	WiFiWrite(n, String(v));
}


//###########################################################################



void HelloWiFi::Scan()
{
	String cmd = "SCAN;";
	print(cmd);
	delay(200);
}


String HelloWiFi::SSIDByID(int v)
{
	flush();
	String cmd = "GET_SSID ";
	cmd += String(v);
	cmd += ";";
	print(cmd);
	
	delay(200);
	String recvData = readStringUntil('#');
	recvData = readStringUntil(';');	
	return recvData;
}


String HelloWiFi::RSSIByID(int v)
{
	flush();
	String cmd = "GET_RSSI ";
	cmd += String(v);
	cmd += ";";
	print(cmd);
	
	delay(200);
	String recvData = readStringUntil('#');
	recvData = readStringUntil(';');	
	return recvData;
}


String HelloWiFi::RSSIByName(String v)
{
	flush();
	String cmd = "GET_RSSI_BY_NAME ";
	cmd += v;
	cmd += ";";
	print(cmd);
	
	delay(200);
	String recvData = readStringUntil('#');
	recvData = readStringUntil(';');	
	return recvData;
}


//###########################################################################


void HelloWiFi::ConnectAP()
{
	String cmd = "CONNECT_AP;";
	print(cmd);
	delay(200);
}


void HelloWiFi::DisconnectAP()
{
	String cmd = "DISCONNECT;";
	print(cmd);
	delay(200);
}

//###########################################################################


void HelloWiFi::Host(String v)
{
	String cmd = "HOST ";
	cmd += v;
	cmd += ";";
	print(cmd);
}


void HelloWiFi::Port(String v)
{
	String cmd = "PORT ";
	cmd += v;
	cmd += ";";
	print(cmd);
}


void HelloWiFi::Path(String v)
{
	String cmd = "PATH ";
	cmd += v;
	cmd += ";";
	print(cmd);
}


void HelloWiFi::UserID(String v)
{
	String cmd = "USER_ID ";
	cmd += v;
	cmd += ";";
	print(cmd);
}


void HelloWiFi::HTTPReqMode(String v)
{
	String cmd = "HTTP_REQ_MODE ";
	cmd += v;
	cmd += ";";
	print(cmd);
}

void HelloWiFi::Interval(int v)
{
	String cmd = "INTERVAL ";
	cmd += String(v);
	cmd += ";";
	print(cmd);
}



//###########################################################################


void HelloWiFi::Send()
{
	String cmd = "SEND;";
	print(cmd);
}



void HelloWiFi::Send(String v)
{
	String cmd = "SEND ";
	cmd += v;
	cmd += ";";
	print(cmd);
}

void HelloWiFi::Send(byte v)
{
	Send(String(v));
}

void HelloWiFi::Send(char v)
{
	Send(String(v));
}

void HelloWiFi::Send(int v)
{
	Send(String(v));
}

void HelloWiFi::Send(unsigned int v)
{
	Send(String(v));
}

void HelloWiFi::Send(long v)
{
	Send(String(v));
}

void HelloWiFi::Send(unsigned long v)
{
	Send(String(v));
}

void HelloWiFi::Send(float v)
{
	Send(String(v));
}

void HelloWiFi::Send(double v)
{
	Send(String(v));
}


//###########################################################################


void HelloWiFi::Send(String n, String v)
{
	String cmd = "SEND ";
	cmd += n;
	cmd += " ";
	cmd += v;
	cmd += ";";
	print(cmd);
}

void HelloWiFi::Send(String n, byte v)
{
	Send(n, String(v));
}

void HelloWiFi::Send(String n, char v)
{
	Send(n, String(v));
}

void HelloWiFi::Send(String n, int v)
{
	Send(n, String(v));
}

void HelloWiFi::Send(String n, unsigned int v)
{
	Send(n, String(v));
}

void HelloWiFi::Send(String n, long v)
{
	Send(n, String(v));
}

void HelloWiFi::Send(String n, unsigned long v)
{
	Send(n, String(v));
}

void HelloWiFi::Send(String n, float v)
{
	Send(n, String(v));
}

void HelloWiFi::Send(String n, double v)
{
	Send(n, String(v));
}



//###########################################################################

void HelloWiFi::SendQuery(String v)
{
	String cmd = "SEND_QUERY ";
	cmd += v;
	cmd += ";";
	print(cmd);
}


void HelloWiFi::SendList()
{
	String cmd = "SEND_LIST;";
	print(cmd);
}


//###########################################################################


void HelloWiFi::IPAddress(String v)
{
	String cmd = "IP_ADDR ";
	cmd += v;
	cmd += ";";
	print(cmd);
}

void HelloWiFi::Gateway(String v)
{
	String cmd = "GATEWAY ";
	cmd += v;
	cmd += ";";
	print(cmd);
}

void HelloWiFi::Subnet(String v)
{
	String cmd = "SUBNET ";
	cmd += v;
	cmd += ";";
	print(cmd);
}

void HelloWiFi::Config()
{
	String cmd = "WIFI_CONFIG;";
	print(cmd);
}


//###########################################################################

