/*-------------------------------------------------------------------------
Developed By HelloApps, (http://www.helloapps.co.kr)
Email: splduino@gmail.com
All rights reserved © 2019, HelloApps Co., Ltd.
2018.10.14 Updated
-------------------------------------------------------------------------*/

#include <Arduino.h>
#include <SoftwareSerial.h>

class HelloWiFi : public SoftwareSerial
{
   public:
      HelloWiFi (int rx, int tx) : SoftwareSerial (rx, tx) { };

	  void Write(byte v);
	  void Write(char v);
	  void Write(int v);
	  void Write(unsigned int v);
	  void Write(long v);
	  void Write(unsigned long v);
	  void Write(float v);
	  void Write(double v);

	  void Print(byte v);
	  void Print(char v);
	  void Print(int v);
	  void Print(unsigned int v);
	  void Print(long v);
	  void Print(unsigned long v);
	  void Print(float v);
	  void Print(double v);
	  void Print(String v);

	  void PrintLine(byte v);
	  void PrintLine(char v);
	  void PrintLine(int v);
	  void PrintLine(unsigned int v);
	  void PrintLine(long v);
	  void PrintLine(unsigned long v);
	  void PrintLine(float v);
	  void PrintLine(double v);
	  void PrintLine(String v);

	  int Read();

	  //###########################################################################

	  
	  String Message();
	  String PrintMessage_v1();
	  String Ver();
	  void SSID(String s);
	  String GetSSID();
	  void Password(String s);
	  void Channel(String s);
	  String GetChannel();
	  String ChannelReassign();
	  
	  void StartAP();
	  void BeginAP();
	  void BeginServer();
	 
	  //###########################################################################
	
	  String WiFiRead();
	  String WiFiRead(String v);

	  //###########################################################################
	  
	  void WiFiWrite(String v);
	  void WiFiWrite(byte v);
	  void WiFiWrite(char v);
	  void WiFiWrite(int v);
	  void WiFiWrite(unsigned int v);
	  void WiFiWrite(long v);
	  void WiFiWrite(unsigned long v);
	  void WiFiWrite(float v);
	  void WiFiWrite(double v);
	  
	  void WiFiWrite(String n, String v);
	  void WiFiWrite(String n, byte v);
	  void WiFiWrite(String n, char v);
	  void WiFiWrite(String n, int v);
	  void WiFiWrite(String n, unsigned int v);
	  void WiFiWrite(String n, long v);
	  void WiFiWrite(String n, unsigned long v);
	  void WiFiWrite(String n, float v);
	  void WiFiWrite(String n, double v);
	  
	  //###########################################################################
	  
	  void Scan();
	  String SSIDByID(int v);
	  String RSSIByID(int v);
	  String RSSIByName(String v);
	  
	  //###########################################################################
	  
	  void ConnectAP();
	  void DisconnectAP();
	  
	  
	  void Host(String v);
	  void Port(String v);
	  void Path(String v);
	  void UserID(String v);
	  void HTTPReqMode(String v);
	  void Interval(int v);
	  	  
	  //###########################################################################
	  	  
	  void Send();

	  void Send(String v);
	  void Send(byte v);
	  void Send(char v);
	  void Send(int v);
	  void Send(unsigned int v);
	  void Send(long v);
	  void Send(unsigned long v);
	  void Send(float v);
	  void Send(double v);
	  
	  void Send(String n, String v);
	  void Send(String n, byte v);
	  void Send(String n, char v);
	  void Send(String n, int v);
	  void Send(String n, unsigned int v);
	  void Send(String n, long v);
	  void Send(String n, unsigned long v);
	  void Send(String n, float v);
	  void Send(String n, double v);
	  
	  void SendQuery(String v);
	  void SendList();
	  
	  void IPAddress(String v);
	  void Gateway(String v);
	  void Subnet(String v);
	  void Config();
	  
	  //###########################################################################
	  

   private:      
      //String _printData;
	  //String _receivedData;
	  //boolean _resetReady = false;
	  byte data_start_flag = 0;
	  String recv_data = "";
};
